#include "KSGSRckruf.h"
#include "../Klassen/KSGSTyp.h"
#include "../Main/KSGScriptObj.h"
#include "../Befehl/KSGSKlasse.h"

using namespace KSGScript;

// Inhalt der KSGSRckrufFInstanz Klasse aus KSGSRckruf.h
// Konstruktor
KSGSRckrufInstanz::KSGSRckrufInstanz( KSGScriptObj *obj )
	: KSGSFunktionInstanz(new RCArray< KSGSBefehl >(), KSGS_VOID, obj, 0 )
{
	parameter = 0;
}

// Destruktor
KSGSRckrufInstanz::~KSGSRckrufInstanz()
{
	if( parameter )
		parameter->release();
}

// nicht constant
void KSGSRckrufInstanz::setParameter( Array< KSGSVariableDef* > *zDef, RCArray< KSGSVariable > *vars )
{
	if( parameter )
		parameter->release();
	parameter = vars;
}

KSGSVariable *KSGSRckrufInstanz::startFunktion()
{
	return obj->rckruf( parameter ? parameter->getThis() : new RCArray< KSGSVariable >() );
}


// Inhalt der KSGSRckrufFunktion Klasse aus KSGSRckruf.h
// Konstruktor
KSGSRckrufFunktion::KSGSRckrufFunktion()
	: KSGSFunktion( 0, 0, KSGS_VOID )
{
}

// nicht constant
KSGSFunktionInstanz *KSGSRckrufFunktion::erstellInstanz( KSGScriptObj *obj, KSGSVariable *klasse, RCArray< KSGSVariable > *params )
{
	KSGSRckrufInstanz *inst = new KSGSRckrufInstanz( obj );
	if( params )
		inst->setParameter( 0, params );
	return inst;
}